(function($) {
  'use strict';

  $(function() {
    // ready
  });

  $('body').on('click touch', '.wpcot-tip-value', function(e) {
    e.preventDefault();
    apply_tip($(this));
  });

  $('body').on('click touch', '.wpcot-tip-value-custom', function(e) {
    e.preventDefault();

    var $this = $(this);

    $this.closest('.wpcot-tip').find('.wpcot-tip-custom').slideToggle();
  });

  $('body').on('click touch', '.wpcot-tip-custom-add', function(e) {
    e.preventDefault();

    var $this = $(this);
    var $tip = $this.closest('.wpcot-tip');
    var value = $tip.find('.wpcot-tip-custom-value').val();
    var key = $tip.data('key');
    var name = $tip.data('name');

    if (value) {
      $this.closest('.wpcot-tip-custom-form').addClass('disabled');
      $tip.find('.wpcot-tip-value-custom').addClass('loading');

      $.ajax({
        type: 'POST', url: wpcot_vars.ajax_url, dataType: 'json', data: ({
          action: 'wpcot_apply_tip',
          key: key,
          name: name,
          value: value,
          security: wpcot_vars.a_nonce,
        }), success: function(response) {
          $this.closest('.wpcot-tip-custom-form').removeClass('disabled');
          $tip.find('.wpcot-tip-value').removeClass('active');
          $tip.find('.wpcot-tip-value-custom').
              removeClass('loading').
              addClass('active');

          $('body').trigger('update_checkout');

          if ($('button[name="update_cart"]').length) {
            $('button[name="update_cart"]').
                attr('aria-disabled', false).
                removeAttr('disabled').
                trigger('click');
          }
        },
      });
    } else {
      $tip.find('.wpcot-tip-custom-value').focus();
    }
  });

  function apply_tip($value) {
    var value = $value.data('value');
    var key = $value.closest('.wpcot-tip').data('key');
    var name = $value.closest('.wpcot-tip').data('name');

    $value.addClass('loading');

    if ($value.hasClass('active') || $value.hasClass('wpcot-tip-value-none')) {
      // remove tip
      $.ajax({
        type: 'POST', url: wpcot_vars.ajax_url, dataType: 'json', data: ({
          action: 'wpcot_remove_tip',
          key: key,
          security: wpcot_vars.r_nonce,
        }), success: function(response) {
          $value.closest('.wpcot-tip').
              find('.wpcot-tip-value').
              removeClass('active loading');

          if ($value.hasClass('wpcot-tip-value-none')) {
            $value.addClass('active');
          }

          $('body').trigger('update_checkout');

          if ($('button[name="update_cart"]').length) {
            $('button[name="update_cart"]').
                attr('aria-disabled', false).
                removeAttr('disabled').
                trigger('click');
          }
        },
      });
    } else {
      $.ajax({
        type: 'POST', url: wpcot_vars.ajax_url, dataType: 'json', data: ({
          action: 'wpcot_apply_tip',
          key: key,
          name: name,
          value: value,
          security: wpcot_vars.a_nonce,
        }), success: function(response) {
          $value.closest('.wpcot-tip').
              find('.wpcot-tip-value').
              removeClass('active');
          $value.removeClass('loading').addClass('active');

          $('body').trigger('update_checkout');

          if ($('button[name="update_cart"]').length) {
            $('button[name="update_cart"]').
                attr('aria-disabled', false).
                removeAttr('disabled').
                trigger('click');
          }
        },
      });
    }
  }
})(jQuery);