<?php
defined( 'ABSPATH' ) || exit;

if ( ! class_exists( 'Wpcot_Helper' ) ) {
	class Wpcot_Helper {
		protected static $localization = array();

		function __construct() {
			add_action( 'init', [ $this, 'init' ] );
		}

		function init() {
			self::$localization = (array) get_option( 'wpcot_localization' );
		}

		public static function localization( $key = '', $default = '' ) {
			$str = '';

			if ( ! empty( $key ) && ! empty( self::$localization[ $key ] ) ) {
				$str = self::$localization[ $key ];
			} elseif ( ! empty( $default ) ) {
				$str = $default;
			}

			return esc_html( apply_filters( 'wpcot_localization_' . $key, $str ) );
		}
	}
}

new Wpcot_Helper();

